#pragma once
#include <cstdint>

// /////////////////////////////////////////////////////////////
// Module: client
// Created using source2gen - github.com/neverlosecc/source2gen
// /////////////////////////////////////////////////////////////

namespace source2sdk::client
{
    // Enumerator count: 214
    // Alignment: 4
    // Size: 0x4
    enum class EModifierValue : std::uint32_t
    {
        MODIFIER_VALUE_MATERIAL_OVERRIDE = 0x0,
        // MPropertyFriendlyName "ProcBuildupPercent"
        MODIFIER_VALUE_PROC_BUILDUP_PERCENTAGE = 0x1,
        // MPropertyFriendlyName "FrictionPercentage"
        MODIFIER_VALUE_FRICTION_PERCENTAGE = 0x2,
        // MPropertyFriendlyName "BaseVelocity"
        // MScriptDescription "MoveType GetModifierBaseVelocity"
        MODIFIER_VALUE_BASE_VELOCITY = 0x3,
        // MPropertyFriendlyName "MoveType"
        // MScriptDescription "TargetIdentifierOverride GetMoveTypeOverride"
        MODIFIER_VALUE_MOVE_TYPE_OVERRIDE = 0x4,
        // MPropertyFriendlyName "TargetIdentifierOverride"
        // MScriptDescription "TargetIdentifierOverrideOrientation GetTargetIdentifierOverride"
        MODIFIER_VALUE_TARGET_IDENTIFIER_OVERRIDE = 0x5,
        // MPropertyFriendlyName "TargetIdentifierOverrideOrientation"
        // MScriptDescription "GetAdditionalVelocity GetTargetIdentifierOverrideOrientation"
        MODIFIER_VALUE_TARGET_IDENTIFIER_OVERRIDE_ORIENTATION = 0x6,
        MODIFIER_VALUE_INCOMING_DAMAGE_PERCENTAGE = 0x7,
        MODIFIER_VALUE_OUTGOING_DAMAGE_PERCENTAGE = 0x8,
        // MScriptDescription "BaseAttackDamage GetAdditionalVelocity"
        MODIFIER_VALUE_ADDITIONAL_VELOCITY = 0x9,
        // MPropertyFriendlyName "BaseAttackDamage"
        MODIFIER_VALUE_BASEATTACK_DAMAGE = 0xa,
        MODIFIER_VALUE_ATTACK_DAMAGE_ADDITIVE_ONLY = 0xb,
        // MPropertyFriendlyName "BaseAttackDamagePercent"
        MODIFIER_VALUE_BASEATTACK_DAMAGE_PERCENT = 0xc,
        // MPropertyFriendlyName "AllDamagePercent"
        MODIFIER_VALUE_DAMAGE_PERCENT = 0xd,
        // MPropertyFriendlyName "BonusBaseWeaponDamage"
        MODIFIER_VALUE_BASE_BULLET_DAMAGE_PERCENT = 0xe,
        MODIFIER_VALUE_BASE_BULLET_DAMAGE_PERCENT_FROM_LEVEL = 0xf,
        MODIFIER_VALUE_BASE_BULLET_DAMAGE_FROM_LEVEL = 0x10,
        MODIFIER_VALUE_BULLET_DAMAGE_PERCENT = 0x11,
        // MPropertyFriendlyName "BonusBaseMeleeDamage"
        MODIFIER_VALUE_BASE_MELEE_DAMAGE_PERCENT = 0x12,
        MODIFIER_VALUE_BASE_MELEE_DAMAGE_PERCENT_FROM_LEVEL = 0x13,
        MODIFIER_VALUE_BASE_MELEE_DAMAGE_FROM_LEVEL = 0x14,
        MODIFIER_VALUE_MELEE_DAMAGE_PERCENT = 0x15,
        // MPropertyFriendlyName "TechDamagePercent"
        MODIFIER_VALUE_TECH_DAMAGE_PERCENT = 0x16,
        // MPropertyFriendlyName "BonusHealth"
        MODIFIER_VALUE_HEALTH_MAX = 0x17,
        // MPropertyFriendlyName "BonusHealthPercent"
        MODIFIER_VALUE_HEALTH_MAX_PERCENT = 0x18,
        MODIFIER_VALUE_BASE_HEALTH_PERCENT = 0x19,
        MODIFIER_VALUE_BASE_HEALTH_FROM_LEVEL = 0x1a,
        MODIFIER_VALUE_BONUS_MAX_HEALTH_NO_SCALE = 0x1b,
        // MPropertyFriendlyName "BonusHealthRegen"
        MODIFIER_VALUE_HEALTH_REGEN_PER_SECOND = 0x1c,
        MODIFIER_VALUE_HEALTH_REGEN_PER_SECOND_PERCENT = 0x1d,
        // MPropertyFriendlyName "BonusRegenMaxHealthPercent"
        MODIFIER_VALUE_REGEN_MAX_HEALTH_PERCENT_PER_SECOND = 0x1e,
        // MPropertyFriendlyName "ExternalBonusHealthRegen"
        MODIFIER_VALUE_EXTERNAL_HEALTH_REGEN_PER_SECOND = 0x1f,
        // MPropertyFriendlyName "OutOfCombatHealthRegen"
        MODIFIER_VALUE_OUT_OF_COMBAT_HEALTH_REGEN = 0x20,
        // MPropertyFriendlyName "HealAmpCastPercent"
        MODIFIER_VALUE_HEAL_AMP_CAST_PERCENT = 0x21,
        // MPropertyFriendlyName "HealAmpReceivePercent"
        MODIFIER_VALUE_HEAL_AMP_RECEIVE_PERCENT = 0x22,
        // MPropertyFriendlyName "HealAmpRegenPercent"
        MODIFIER_VALUE_HEAL_AMP_REGEN_PERCENT = 0x23,
        // MPropertyFriendlyName "HealDegenResistance"
        MODIFIER_VALUE_HEAL_DEGEN_RESISTANCE = 0x24,
        // MPropertyFriendlyName "BonusClipSize"
        MODIFIER_VALUE_AMMO_CLIP_SIZE = 0x25,
        // MPropertyFriendlyName "BonusClipSizePercent"
        MODIFIER_VALUE_AMMO_CLIP_SIZE_PERCENT = 0x26,
        // MPropertyFriendlyName "ClipSizeOverride"
        MODIFIER_VALUE_AMMO_CLIP_SIZE_OVERRIDE = 0x27,
        // MPropertyFriendlyName "ReloadSpeedMultipler"
        MODIFIER_VALUE_RELOAD_SPEED = 0x28,
        // MPropertyFriendlyName "ReloadSpeedConstant"
        MODIFIER_VALUE_RELOAD_SPEED_CONSTANT = 0x29,
        MODIFIER_VALUE_MOVE_SPEED_LIMIT = 0x2a,
        // MPropertyFriendlyName "BonusMoveSpeed"
        MODIFIER_VALUE_MOVEMENT_SPEED_MAX = 0x2b,
        // MPropertyFriendlyName "BonusMoveSpeedPercent"
        MODIFIER_VALUE_MOVEMENT_SPEED_MAX_PERCENT = 0x2c,
        // MPropertyFriendlyName "MoveWhileZoomedSpeedPenaltyReductionPercent"
        MODIFIER_VALUE_MOVEMENT_SPEED_WHILE_ZOOMED_PENALTY_REDUCTION_PERCENT = 0x2d,
        // MPropertyFriendlyName "MoveWhileShootingSpeedPenaltyReductionPercent"
        MODIFIER_VALUE_MOVEMENT_SPEED_WHILE_SHOOTING_PENALTY_REDUCTION_PERCENT = 0x2e,
        // MPropertyFriendlyName "MoveSpeedSlowPercent"
        MODIFIER_VALUE_MOVEMENT_SPEED_SLOW_PERCENT = 0x2f,
        // MPropertyFriendlyName "MoveGroundReductionPercent"
        MODIFIER_VALUE_MOVEMENT_GROUND_DASH_REDUCTION_PERCENT = 0x30,
        // MPropertyFriendlyName "MoveDashIncreasePercent"
        MODIFIER_VALUE_MOVEMENT_GROUND_DASH_INCREASE_PERCENT = 0x31,
        // MPropertyFriendlyName "AirMoveIncreasePercent"
        MODIFIER_VALUE_AIR_MOVE_DISTANCE_INCREASE_PERCENT = 0x32,
        // MPropertyFriendlyName "SlideDistanceScale"
        MODIFIER_VALUE_MOVEMENT_SLIDE_DISTANCE_SCALE = 0x33,
        // MPropertyFriendlyName "SlowResistance"
        MODIFIER_VALUE_MOVEMENT_SLOW_RESISTANCE = 0x34,
        // MPropertyFriendlyName "BonusAttackRange"
        MODIFIER_VALUE_BONUS_ATTACK_RANGE = 0x35,
        // MPropertyFriendlyName "BonusAttackRangePercent"
        MODIFIER_VALUE_BONUS_ATTACK_RANGE_PERCENT = 0x36,
        // MPropertyFriendlyName "BonusZoomPercent"
        MODIFIER_VALUE_ZOOM_INCREASE_PERCENT = 0x37,
        MODIFIER_VALUE_ZOOM_POSITION = 0x38,
        // MPropertyFriendlyName "WeaponRecoilReduction"
        MODIFIER_VALUE_WEAPON_RECOIL_REDUCTION_PERCENT = 0x39,
        // MPropertyFriendlyName "BonusSprintSpeed"
        MODIFIER_VALUE_SPRINT_SPEED_BONUS = 0x3a,
        // MPropertyFriendlyName "BonusSprintSpeedPercent"
        MODIFIER_VALUE_SPRINT_SPEED_MAX_PERCENT = 0x3b,
        MODIFIER_VALUE_SPRINT_DURATION = 0x3c,
        MODIFIER_VALUE_SPRINT_ACCELERATION = 0x3d,
        MODIFIER_VALUE_DISPLAY_SPEED_CURRENT = 0x3e,
        MODIFIER_VALUE_DISPLAY_SPEED_MAX = 0x3f,
        MODIFIER_VALUE_AVOID_SPELL = 0x40,
        // MPropertyFriendlyName "BonusFireRate"
        MODIFIER_VALUE_FIRE_RATE = 0x41,
        // MPropertyFriendlyName "FireRateSlow"
        MODIFIER_VALUE_FIRE_RATE_SLOW = 0x42,
        // MPropertyFriendlyName "CycleTimeMultiplier"
        MODIFIER_VALUE_CYCLE_TIME_PERCENTAGE = 0x43,
        MODIFIER_VALUE_SPREAD_SCALE = 0x44,
        MODIFIER_VALUE_CYCLE_TIME = 0x45,
        MODIFIER_VALUE_AMMO_COST_REDUCTION = 0x46,
        MODIFIER_VALUE_DAMAGE_TAKEN_REDUCTION_PERCENT = 0x47,
        MODIFIER_VALUE_DAMAGE_TAKEN_INCREASE_PERCENT = 0x48,
        MODIFIER_VALUE_BULLET_DAMAGE_TAKEN_INCREASE_PERCENT = 0x49,
        MODIFIER_VALUE_ABILITY_DAMAGE_TAKEN_INCREASE_PERCENT = 0x4a,
        // MPropertyFriendlyName "TechArmor"
        MODIFIER_VALUE_TECH_ARMOR = 0x4b,
        // MPropertyFriendlyName "TechResist"
        MODIFIER_VALUE_TECH_ARMOR_DAMAGE_RESIST = 0x4c,
        MODIFIER_VALUE_TECH_ARMOR_DAMAGE_RESIST_PERCENT = 0x4d,
        MODIFIER_VALUE_TECH_ARMOR_DAMAGE_RESIST_REDUCTION = 0x4e,
        // MPropertyFriendlyName "AbilityDamageReduction"
        MODIFIER_VALUE_ABILITY_DAMAGE_REDUCTION = 0x4f,
        MODIFIER_VALUE_ABILITY_DAMAGE_REDUCTION_PERCENT = 0x50,
        // MPropertyFriendlyName "BulletArmor"
        MODIFIER_VALUE_BULLET_ARMOR = 0x51,
        // MPropertyFriendlyName "BulletResist"
        MODIFIER_VALUE_BULLET_ARMOR_DAMAGE_RESIST = 0x52,
        MODIFIER_VALUE_BULLET_ARMOR_DAMAGE_RESIST_PERCENT = 0x53,
        MODIFIER_VALUE_BULLET_ARMOR_DAMAGE_RESIST_REDUCTION = 0x54,
        MODIFIER_VALUE_BULLET_ARMOR_DAMAGE_RESIST_NON_HERO = 0x55,
        MODIFIER_VALUE_CRIT_DAMAGE_RECEIVED_SCALE = 0x56,
        // MPropertyFriendlyName "BulletDamageReduction"
        MODIFIER_VALUE_BULLET_DAMAGE_REDUCTION = 0x57,
        MODIFIER_VALUE_BULLET_DAMAGE_REDUCTION_PERCENT = 0x58,
        // MPropertyFriendlyName "BaseWeaponDamageTakenPercent"
        MODIFIER_VALUE_BASE_WEAPON_DAMAGE_TAKEN_PERCENT = 0x59,
        // MPropertyFriendlyName "BaseBulletDamageTakenPercent"
        MODIFIER_VALUE_BASE_BULLET_DAMAGE_TAKEN_PERCENT = 0x5a,
        // MPropertyFriendlyName "BaseMeleeDamageTakenPercent"
        MODIFIER_VALUE_BASE_MELEE_DAMAGE_TAKEN_PERCENT = 0x5b,
        // MPropertyFriendlyName "MeleeDamageReductionPercent"
        MODIFIER_VALUE_MELEE_DAMAGE_REDUCTION_PERCENT = 0x5c,
        MODIFIER_VALUE_MELEE_DAMAGE_INCREASE_PERCENT = 0x5d,
        // MPropertyFriendlyName "StatusResistancePercent"
        MODIFIER_VALUE_STATUS_RESISTANCE = 0x5e,
        // MPropertyFriendlyName "CooldownReduction"
        MODIFIER_VALUE_COOLDOWN_REDUCTION_PERCENTAGE = 0x5f,
        MODIFIER_VALUE_COOLDOWN_MAX_TIME = 0x60,
        // MPropertyFriendlyName "CooldownBetweenChargeReduction"
        MODIFIER_VALUE_COOLDOWN_BETWEEN_CHARGE_REDUCTION_PERCENTAGE = 0x61,
        // MPropertyFriendlyName "BonusAbilityCharges"
        MODIFIER_VALUE_BONUS_ABILITY_CHARGES = 0x62,
        // MPropertyFriendlyName "BonusAbilityDurationPercent"
        MODIFIER_VALUE_BONUS_ABILITY_DURATION_PERCENTAGE = 0x63,
        // MPropertyFriendlyName "BonusMeleeDamage"
        MODIFIER_VALUE_MELEEATTACK_DAMAGE = 0x64,
        MODIFIER_VALUE_MELEEATTACK_DAMAGE_PERCENTAGE = 0x65,
        // MPropertyFriendlyName "BonusMeleeAttackSpeed"
        MODIFIER_VALUE_MELEEATTACK_SPEED = 0x66,
        // MPropertyFriendlyName "BonusMeleeTravelDistancePercent"
        MODIFIER_VALUE_MELEE_TRAVEL_DISTANCE_PERCENTAGE = 0x67,
        // MPropertyFriendlyName "ParryCooldownReductionFixed"
        MODIFIER_VALUE_PARRY_COOLDOWN_REDUCTION_FIXED = 0x68,
        // MPropertyFriendlyName "BonusAccuracy"
        MODIFIER_VALUE_FIREARM_ACCURACY_PERCENTAGE = 0x69,
        MODIFIER_VALUE_TURN_SIDEMOVE_PERCENTAGE = 0x6a,
        MODIFIER_VALUE_CHARGE_SPEED = 0x6b,
        MODIFIER_VALUE_TELEPORT_COOLDOWN_REDUCTION_PERCENT = 0x6c,
        MODIFIER_VALUE_FALL_SPEED_MAX = 0x6d,
        MODIFIER_VALUE_AIR_SPEED_MAX = 0x6e,
        MODIFIER_VALUE_GRAVITY_SCALE = 0x6f,
        MODIFIER_VALUE_BULLET_EVASION = 0x70,
        // MPropertyFriendlyName "BulletShieldHealth"
        MODIFIER_VALUE_BULLET_SHIELD_HEALTH = 0x71,
        // MPropertyFriendlyName "BulletShieldMaxHealth"
        MODIFIER_VALUE_BULLET_SHIELD_HEALTH_MAX = 0x72,
        MODIFIER_VALUE_BULLET_SHIELD_DAMAGE_PERCENT = 0x73,
        // MPropertyFriendlyName "BarrierHealth "
        MODIFIER_VALUE_BARRIER_HEALTH = 0x74,
        // MPropertyFriendlyName "BonusCritDamagePercent"
        MODIFIER_VALUE_BONUS_CRIT_DAMAGE_PERCENT = 0x75,
        // MPropertyFriendlyName "HighGroundBonusBaseDamagePercent"
        MODIFIER_VALUE_HEIGHT_ADVANTAGE_BONUS_BASE_DAMAGE_PERCENT = 0x76,
        // MPropertyFriendlyName "CloseRangeBonusBaseDamage"
        MODIFIER_VALUE_CLOSE_RANGE_BONUS_BASE_DAMAGE_PERCENT = 0x77,
        MODIFIER_VALUE_BONUS_WEAPON_DAMAGE_CLOSE_RANGE_MAX_RANGE = 0x78,
        // MPropertyFriendlyName "LongRangeBonusWeaponPower"
        MODIFIER_VALUE_LONG_RANGE_BONUS_BASE_DAMAGE_PERCENT = 0x79,
        MODIFIER_VALUE_BONUS_WEAPON_DAMAGE_LONG_RANGE_MIN_RANGE = 0x7a,
        // MPropertyFriendlyName "TechRangeAdditive"
        MODIFIER_VALUE_TECH_RANGE_ADDITIVE = 0x7b,
        // MPropertyFriendlyName "TechRangeMultiplier"
        MODIFIER_VALUE_TECH_RANGE_PERCENT = 0x7c,
        MODIFIER_VALUE_TECH_RANGE_CLAMP = 0x7d,
        // MPropertyFriendlyName "TechRadiusAdditive"
        MODIFIER_VALUE_TECH_RADIUS_ADDITIVE = 0x7e,
        // MPropertyFriendlyName "TechRadiusMultiplier"
        MODIFIER_VALUE_TECH_RADIUS_PERCENT = 0x7f,
        MODIFIER_VALUE_TURN_ANGLE_PER_SECOND_MAX = 0x80,
        MODIFIER_VALUE_BONUS_JUMP_VERTICAL_SPEED_PERCENT = 0x81,
        MODIFIER_VALUE_AIR_JUMPS = 0x82,
        // MPropertyFriendlyName "BonusZipLineSpeed"
        MODIFIER_VALUE_ZIP_LINE_SPEED_ADDITIVE = 0x83,
        // MPropertyFriendlyName "ZipLineSpeedPercent"
        MODIFIER_VALUE_ZIP_LINE_SPEED_PERCENTAGE = 0x84,
        // MPropertyFriendlyName "ClimbRopeSpeedPercent"
        MODIFIER_VALUE_CLIMB_ROPE_SPEED_PERCENTAGE = 0x85,
        // MPropertyFriendlyName "GroundFrictionPercent"
        MODIFIER_VALUE_GROUND_FRICTION_PERCENTAGE = 0x86,
        // MPropertyFriendlyName "GroundAccelerationPercent"
        MODIFIER_VALUE_GROUND_ACCELERATION_PERCENTAGE = 0x87,
        MODIFIER_VALUE_INVISIBILITY_LEVEL = 0x88,
        MODIFIER_VALUE_CLOAK_FACTOR = 0x89,
        MODIFIER_VALUE_CLOAK_DESAT_FACTOR = 0x8a,
        MODIFIER_VALUE_PARTICLE_TINT_OVERRIDE = 0x8b,
        MODIFIER_VALUE_PARTICLE_DESAT_OVERRIDE = 0x8c,
        MODIFIER_VALUE_DIMENSION_TYPE = 0x8d,
        MODIFIER_VALUE_GAMEPLAY_TIME_SCALE_ADDITIVE = 0x8e,
        MODIFIER_VALUE_GAMEPLAY_TIME_SCALE_PERCENT = 0x8f,
        MODIFIER_VALUE_ANIMATION_TIME_SCALE_ADDITIVE = 0x90,
        MODIFIER_VALUE_ANIMATION_TIME_SCALE_PERCENT = 0x91,
        MODIFIER_VALUE_ANIMATION_FRAME_SKIP_RATE = 0x92,
        MODIFIER_VALUE_MOVEMENT_TIME_SCALE_ADDITIVE = 0x93,
        MODIFIER_VALUE_MOVEMENT_TIME_SCALE_PERCENT = 0x94,
        MODIFIER_VALUE_PARTICLE_TIME_SCALE_ADDITIVE = 0x95,
        MODIFIER_VALUE_PARTICLE_TIME_SCALE_PERCENT = 0x96,
        // MPropertyFriendlyName "Stamina"
        MODIFIER_VALUE_STAMINA = 0x97,
        MODIFIER_VALUE_STAMINA_REGEN_PER_SECOND_ADDITIVE = 0x98,
        // MPropertyFriendlyName "StaminaRegenPercent"
        MODIFIER_VALUE_STAMINA_REGEN_PER_SECOND_PERCENTAGE = 0x99,
        // MPropertyFriendlyName "WeaponPower"
        MODIFIER_VALUE_WEAPON_POWER = 0x9a,
        // MPropertyFriendlyName "ArmorPower"
        MODIFIER_VALUE_ARMOR_POWER = 0x9b,
        // MPropertyFriendlyName "TechPower"
        MODIFIER_VALUE_TECH_POWER = 0x9c,
        // MPropertyFriendlyName "TechPowerPercent"
        MODIFIER_VALUE_TECH_POWER_PERCENT = 0x9d,
        // MPropertyFriendlyName "WeaponPowerPercent"
        MODIFIER_VALUE_WEAPON_POWER_PERCENT = 0x9e,
        // MPropertyFriendlyName "AirControlPercent"
        MODIFIER_VALUE_AIR_CONTROL_PERCENT = 0x9f,
        // MPropertyFriendlyName "AirControlAccelPercent"
        MODIFIER_VALUE_AIR_CONTROL_ACCEL_PERCENT = 0xa0,
        // MPropertyFriendlyName "AbilityProjectileSpeedPercent"
        MODIFIER_VALUE_ABILITY_PROJECTILE_SPEED_PERCENT = 0xa1,
        // MPropertyFriendlyName "BonusBulletSpeedPercent"
        MODIFIER_VALUE_BONUS_BULLET_SPEED_PERCENT = 0xa2,
        // MPropertyFriendlyName "BaseBulletSpeedOverride"
        MODIFIER_VALUE_BASE_BULLET_SPEED_OVERRIDE = 0xa3,
        MODIFIER_VALUE_BULLET_SHOOT_SOUND = 0xa4,
        MODIFIER_VALUE_BULLET_SHOOT_SOUND_FRIENDLY = 0xa5,
        MODIFIER_VALUE_BULLET_SHOOT_SOUND_ENEMY = 0xa6,
        MODIFIER_VALUE_BULLET_SHOOT_SOUND_WHIZ = 0xa7,
        MODIFIER_VALUE_BULLET_SHOOT_SOUND_WHIZ_LEFT_TO_RIGHT = 0xa8,
        MODIFIER_VALUE_BULLET_SHOOT_SOUND_WHIZ_RIGHT_TO_LEFT = 0xa9,
        MODIFIER_VALUE_TRACER_REPLACEMENT = 0xaa,
        MODIFIER_VALUE_TRACER_ADDITIONAL = 0xab,
        // MPropertySuppressEnumerator
        MODIFIER_VALUE_CAMERA_TARGET_OVERRIDE = 0xac,
        MODIFIER_VALUE_SPECTATING_SPEED_OVERRIDE = 0xad,
        // MPropertyFriendlyName "NonPlayerBonusWeaponPower"
        MODIFIER_NON_PLAYER_BONUS_BASE_DAMAGE_PERCENT = 0xae,
        MODIFIER_VALUE_AIR_DRAG = 0xaf,
        MODIFIER_VALUE_TECH_DAMAGE_TAKEN_HEALS_ATTACKER = 0xb0,
        MODIFIER_VALUE_BULLET_DAMAGE_TAKEN_HEALS_ATTACKER = 0xb1,
        // MPropertyFriendlyName "AbilityLifestealPercentHero"
        MODIFIER_VALUE_TECH_LIFESTEAL = 0xb2,
        // MPropertyFriendlyName "BulletLifestealPercent"
        MODIFIER_VALUE_BULLET_LIFESTEAL = 0xb3,
        MODIFIER_VALUE_OVERRIDE_BULLET_ATTACKER = 0xb4,
        MODIFIER_VALUE_OVERRIDE_MELEE_HIT_SOUND = 0xb5,
        MODIFIER_VALUE_OVERRIDE_MELEE_MISS_SOUND = 0xb6,
        // MPropertyFriendlyName "ImbuedBonusDamage"
        MODIFIER_VALUE_IMBUED_BONUS_DAMAGE = 0xb7,
        // MPropertyFriendlyName "ImbuedBonusDuration"
        MODIFIER_VALUE_IMBUED_BONUS_DURATION = 0xb8,
        // MPropertyFriendlyName "IntraBurstShotCycleTimeOverride"
        MODIFIER_VALUE_INTRA_BURST_SHOT_CYCLE_TIME_OVERRIDE = 0xb9,
        // MPropertyFriendlyName "BonusBurstShotPercent"
        MODIFIER_VALUE_BONUS_BURST_SHOT_PERCENT = 0xba,
        // MPropertyFriendlyName "BonusBurstShotConstant"
        MODIFIER_VALUE_BONUS_BURST_SHOT_CONSTANT = 0xbb,
        // MPropertyFriendlyName "SpinUpRateOverride"
        MODIFIER_VALUE_SPIN_UP_RATE_OVERRIDE = 0xbc,
        // MPropertyFriendlyName "SpinUpDecayOverride"
        MODIFIER_VALUE_SPIN_UP_DECAY_OVERRIDE = 0xbd,
        // MPropertyFriendlyName "SpinUpMaxCycleTimeOverride"
        MODIFIER_VALUE_SPIN_UP_MAX_CYCLE_TIME_OVERRIDE = 0xbe,
        // MPropertyFriendlyName "SpinUpMaxBurstFireCooldownOverride"
        MODIFIER_VALUE_SPIN_UP_MAX_BURST_FIRE_COOLDOWN_OVERRIDE = 0xbf,
        MODIFIER_VALUE_SPIN_UP_SOUND_OVERRIDE = 0xc0,
        MODIFIER_VALUE_SPIN_DOWN_SOUND_OVERRIDE = 0xc1,
        MODIFIER_VALUE_SPIN_LOOP_SOUND_OVERRIDE = 0xc2,
        // MPropertyFriendlyName "BonusChannelTimePercentage"
        MODIFIER_VALUE_BONUS_CHANNEL_TIME_PERCENTAGE = 0xc3,
        MODIFIER_VALUE_ABILITY_RESOURCE_MAX_ADDITIVE = 0xc4,
        MODIFIER_VALUE_ABILITY_RESOURCE_REGEN_PER_SECOND_ADDITIVE = 0xc5,
        MODIFIER_VALUE_ABILITY_RESOURCE_REGEN_PER_SECOND_PERCENTAGE = 0xc6,
        MODIFIER_VALUE_PENDING_INCOMING_DAMAGE = 0xc7,
        MODIFIER_VALUE_CAMERA_WOBBLE_INTENSITY = 0xc8,
        MODIFIER_VALUE_CAMERA_WOBBLE_SPEED = 0xc9,
        MODIFIER_VALUE_RESPAWN_TIME_ADDITIVE = 0xca,
        MODIFIER_VALUE_RESPAWN_RAMP_TIME_REDUCTION_PERCENT = 0xcb,
        MODIFIER_VALUE_BOON_COUNT = 0xcc,
        MODIFIER_VALUE_FOOTSTEP_ADDITIONAL = 0xcd,
        MODIFIER_VALUE_FOOTSTEP_OVERRIDE = 0xce,
        MODIFIER_VALUE_MODEL_SCALE = 0xcf,
        MODIFIER_VALUE_MODEL_CHANGE = 0xd0,
        MODIFIER_VALUE_HERO_BULLET_LIFESTEAL_EFFECTIVENESS = 0xd1,
        MODIFIER_VALUE_HERO_SPIRIT_LIFESTEAL_EFFECTIVENESS = 0xd2,
        MODIFIER_VALUE_PARRY_FX_OVERRIDE = 0xd3,
        // MPropertySuppressEnumerator
        MODIFIER_VALUE_COUNT = 0xd4,
        // MPropertySuppressEnumerator
        MODIFIER_VALUE_INVALID = 0xff,
    };
};
